package reversie1_1.client.gui;

import java.awt.Dialog;
import java.awt.Button;
import java.awt.TextField;
import java.awt.Label;
import java.awt.Panel;
import java.awt.Frame;
import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.GridLayout;

import reversie1_1.client._RevClientImpl;

class LoginDialog extends Dialog
{
  public LoginDialog(Frame parent,
		     _RevClientImpl client,
		     Button loginButton,
		     Button registerButton,
		     LoginListener loginListener,
		     LogoutListener logoutListener,
		     OkDialog okDialog)
  {
    //create the components for this dialog box
    //labels
    super(parent, "Reversie Server Login", true);
    this.setLayout(new BorderLayout());
    
    Label guestMessage = new Label("Use 'guest' if you don't have an account");
    TextField nameLabel = new TextField("Name", 8);
    TextField passwordLabel = new TextField("Password", 8);
    nameLabel.setEditable(false);
    passwordLabel.setEditable(false);
    
    //textfields
    TextField name = new TextField(20);
    TextField password = new TextField(20);
    password.setEchoChar('*');
    
    //buttons
    Button okButton = new Button("Cancel");
    Button cancelButton = new Button("Cancel");
    okButton.addActionListener(
			       new OkListener(client,
					      name, 
					      password,
					      this,
					      loginButton,
					      registerButton,
					      loginListener,
					      logoutListener,
					      okDialog));
    cancelButton.addActionListener(new CancelListener(this));
    
    Panel g1 = new Panel(new FlowLayout());
    Panel g2 = new Panel(new FlowLayout());
    g1.add(nameLabel);
    g1.add(name);
    g1.add(okButton);
    g2.add(passwordLabel);
    g2.add(password);
    g2.add(cancelButton);
    
    Panel column = new Panel(new GridLayout(3,1));
    column.add(guestMessage);
    column.add(g1);
    column.add(g2);
    
    Panel all = new Panel(new BorderLayout());
    all.add(column, BorderLayout.WEST);
    all.validate();
    
    this.add(all, BorderLayout.NORTH);
    this.pack();
    okButton.setLabel("  Ok  ");
  }
}
