package reversie1_1.client.gui;

import java.awt.Component;
import java.awt.Color;
import java.awt.Dialog;
import java.awt.Button;
import java.awt.TextField;
import java.awt.Label;
import java.awt.Panel;
import java.awt.Frame;
import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.event.ActionListener;
import java.applet.Applet;
import java.applet.AudioClip;
import java.net.URL;

import reversie1_1.client._RevClientImpl;
import reversie1_1.server.corba.RevServer;
import reversie1_1.server.corba.RevServerHelper;

// CORBA stuff here
import ORG.omg.CORBA.*;   // holder classes
import ORG.omg.CosNaming.*;   // the naming service

import EDU.rutgers.CORBA.clntsrv.PortableServer.*; // ORB, POA, etc
import EDU.rutgers.CORBA.clntsrv.PortableServer.POAPackage.*; // exceptions

public class Reversie extends java.applet.Applet 
{
  // the client object
  _RevClientImpl client_;
  Frame parent_;
  
  // ORB arguments
  public void init() 
    {
      this.corbaInit();
      this.initThisApplet();
      this.validate();
    }

  public void corbaInit()
    {
      // ORB initialization stuff here
      String[] orbArgs = {"-ORBPort",
				"5202",
				"-ORBInitialPort",
				"5200",
				"-ORBInitialHost",
				""};
      orbArgs[5] = this.getParameter("ORBInitialHost");

      // initialize the ORB
      ORB orb = ORB.init(orbArgs, null);

      // initialize POA
      POA poa = orb.POA_init();

      // creating the object reference
      ORG.omg.CORBA.Object reference = 
	orb.resolve_initial_references("NameService");
      
      NamingContext c = NamingContextHelper.narrow(reference);

      NameComponent nc = new NameComponent("ReversieServer", "");
      NameComponent[] path = {nc};
      reference = c.resolve(path);
      RevServer stub = RevServerHelper.narrow(reference);
      client_ = new _RevClientImpl(stub);

      orb.connect(client_);
    }
  
  void initThisApplet()
    {
      parent_ = getAppletParent();
      setLayout(new BorderLayout());

      //labels
      Label welcomeLabel =
	new Label("Welcome to the Internet Reversie Server");
      Label welcomeLabel2 =
	new Label("Enjoy your playing!");
  
      Button loginButton = new Button("Login");
      Button registerButton = new Button("Register");
      registerButton.setEnabled(false);


      AudioClip wheee = null;
      try
	{
	  wheee = this.getAudioClip(new URL(getDocumentBase(), "wheee.au"));
	}
      catch(Exception e)
	{
	  System.out.println("@Reversie.init(): could not load sounds: " + e);
	}
      
      
      OkDialog okDialog = new OkDialog(parent_, wheee);
      
      LoginListener loginListener = new LoginListener(null);
      LoginListener regListener =
	new LoginListener(new RegisterDialog(parent_, 
					     client_, 
					     registerButton,
					     okDialog));

      loginButton.addActionListener(loginListener);
      LogoutListener logoutListener =
        new LogoutListener(client_, loginButton, registerButton,
			   loginListener);
      registerButton.addActionListener(regListener);

      Panel logRegPanel = new Panel(new FlowLayout());
      logRegPanel.setBackground(Color.lightGray);
      logRegPanel.add(loginButton);
      logRegPanel.add(registerButton);

      Panel welcomePanel = new Panel(new GridLayout(3,1));
      welcomePanel.setBackground(Color.lightGray);
      
      welcomePanel.add(welcomeLabel);
      welcomePanel.add(welcomeLabel2);
      welcomePanel.add(logRegPanel);
      
      Panel freezeWelcomePanel = new Panel(new BorderLayout());
      freezeWelcomePanel.setBackground(Color.lightGray);
      freezeWelcomePanel.add(welcomePanel, BorderLayout.WEST);

      add(freezeWelcomePanel, BorderLayout.NORTH);
      
      setBackground(Color.lightGray);

      loginListener.dialog_ = 
	new LoginDialog(parent_, client_,
			loginButton,
			registerButton,
			loginListener,
			logoutListener,
			okDialog);
    }

  Frame getAppletParent()
    {
      Component comp = this.getParent().getParent();
      if(comp == null)
	comp = this.getParent();
      return (Frame)comp;
    }
}
