package reversie1_1.server;

import java.util.*;

import reversie1_1.server.corba.*;
import reversie1_1.client.corba.RevClient;

public class _RevServerImpl extends _RevServerImplBase
{
  protected final int MAX_USERS = 500;

  protected Hashtable users_;
  protected Stack tickets_;
  protected User[] loggedUsers_;
  protected int usersNo_, guestsNo_;

  public _RevServerImpl()
    {
      users_ = new Hashtable();
      usersNo_ = guestsNo_ = 0;
      tickets_ = new Stack(MAX_USERS);
      loggedUsers_ = new User[MAX_USERS + 1];
    }
  
  public short logUser(String name, String password, RevClient clRef)
    {
      synchronized(this)
	{
	  User u = (User)users_.get(name);
	  if(u == null) return -1;          // no such user
	  if(!u.password_.equals(password)) return -1; // incorrect password
	  if(u.id_ >= 0) return -1;         // already logged
	  try
	    {
	      u.id_ = tickets_.pop();
	    }
	  catch(EmptyStack e)
	    {
	      return -1;      // maximum number of logged users exceeded
	    }
	  u.client_ = clRef;
	  loggedUsers_[u.id_] = u;
	  return u.id_;
	}
    }

  public short logGuest(RevClient clRef)
    {
      synchronized(this)
	{
	  User u = new User((short)-1, null, null, clRef);
	  try
	    {
	      u.id_ = tickets_.pop();
	    }
	  catch(EmptyStack e)
	    {
	      return -1;      // maximum number of logged users exceeded
	    }
	  u.name_ = "guest" + u.id_;
	  users_.put(u.name_, u);
	  loggedUsers_[u.id_] = u;
	  return u.id_;
	}
    }

  public boolean createUser(String name, String password, short id)
    {
      synchronized(this)
	{
	  if(name.length() >= 5)
	    if(name.substring(0, 5).equals("guest")) // illegal name
	      return false;

	  User clash = (User)users_.get(name);
	  if(clash != null) return false;          // clash with other name

	  User u = loggedUsers_[id];
	  users_.remove(u.name_);          // remove the old name
	  u.name_ = name;
	  u.password_ = password;
	  users_.put(u.name_, u);
	  return true;
	}
    }

  public void logout(short id)
    {
      synchronized(this)
	{
	  if((id > 0) && (id <= MAX_USERS))
	    {
	      User u = loggedUsers_[id];
	      loggedUsers_[id] = null;
	      u.id_ = -1;
	      u.client_ = null;
	      if(u.password_ == null) // it's a guest!
		{ // remove it from the registered users
		  users_.remove(u.name_);
		}
	    }
	}
    }
}
